%MACRO calc_hl_stats_central(tbl_name1_in=
                                                    ,tbl_name2_in=
													,tbl_name_hl_partition_out=
                                                    ,tbl_name_hl_chisq_out=
													,groups=10
                                                    ,prefix0=);

/*
  Usage:
  %LET prefix0=l1_;
 %calc_hl_stats_central(tbl_name1_in=msoc.&prefix0.resid_sum_by_pct
									   ,tbl_name2_in=msoc.&prefix0.resid_sum_by_pct2
                                       ,tbl_name_hl_partition_out=msoc.&prefix0.hl_partition
                                       ,tbl_name_hl_chisq_out=msoc.&prefix0.HL_ChiSq
                                       ,prefix0=&prefix0.);
  
  */

	/* Prepare dataset for input into %calc_hl_stats (HosmerLemeshow statistic) */ 

			DATA &prefix0.resid_sum_by_pct2a;
			   LENGTH dp_cd _MEAN_ 8;
			   SET &tbl_name2_in(KEEP=_FREQ_ _MEAN__Dist_Cnt _MEAN__Mean   
		                                                    _RESP__Mean _ADJ_VARIANCE__Mean
                                                 );
						_sml_=1E-10;
					dp_cd=.;
				    _FREQ_orig=_FREQ_; 
			
				DO i=1 TO _MEAN__Dist_Cnt;
					IF i=1  THEN
						      DO;
						_MEAN_=_MEAN__Mean;
						  _FREQ_= _FREQ_orig -_MEAN__Dist_Cnt +1;
						  OUTPUT;
							  END;
						ELSE DO;
						     _FREQ_=1;
						/*	_MEAN_=_MEAN__Mean*(1.0+ (i-1)*_sml_);	*/
							 _MEAN_=_MEAN__Mean+(i-1)*_sml_;
							 IF _MEAN_ 	>1 THEN _MEAN_=1;
							OUTPUT;
							     END;
					END;

				FORMAT _MEAN_ 	_MEAN__Mean   E32.28;

               RENAME _RESP__Mean=_RESP_
							 _ADJ_VARIANCE__Mean=_ADJ_VARIANCE_
                   ;
			 DROP _MEAN__Mean _FREQ_orig  _MEAN__Dist_Cnt i  _sml_;
			 RUN;

					%sum_by_pct2(tbl_name_in=&prefix0.resid_sum_by_pct2a
			                    ,tbl_name_out= &prefix0.resid_sum_by_pct2b
			                    ,x_var= _MEAN_
								,freq=_FREQ_
                                ,y_var=_RESP_ _ADJ_VARIANCE_  
								,stats_for_y_vars=%STR(MEAN=  )
								,min_count_per_grp=1
                                ,groups=&groups.);

				/* 20171127. Limited calculation of HL statistic to standard test only Test_type=1;*/

			  DATA &prefix0.data_for_hl;
				 LENGTH dp_cd 8;
				  SET &prefix0.resid_sum_by_pct2b(IN=in_comb)
						  /* msoc.&prefix0.resid_sum_by_pct	*/
                            ;
					IF in_comb THEN dp_cd=.;
		
					KEEP dp_cd  Rank__MEAN_ _FREQ_ _MEAN__Mean _RESP__Mean 
                               _ADJ_VARIANCE__Mean ;
				RUN;

				%calc_hl_stats(tbl_name_in=&prefix0.data_for_hl
                                            ,tbl_name_hl_partition_out=&tbl_name_hl_partition_out.
                                            ,tbl_name_hl_chisq_out=&prefix0.HL_ChiSq_dp2);

			  /* dp_cd >0 excludes overall HL stats from calculating a Lingling version of HL test.  
			  The later is based on 10 groups from each dp_cd. */

 			 	/* 20171127. Limited calculation of HL statistic to standard test only Test_type=1;*/
	
			  /* Test_type=1 is standard HL test with 10 groups. Test_type=2 is Lingling */

  DATA &tbl_name_hl_chisq_out.;
  LENGTH dp_cd Test_type 8;
   SET /*&prefix0.HL_ChiSq_All(IN=in_all) */
          &prefix0.HL_ChiSq_dp2(DROP=ChiSq_t ProbChiSq_t)		   
           ;
	/*RETAIN N_dps_tmp;	 */
		 
		 df=N_groups-2;
		 Test_type=1; 
		 ValueDF=ChiSq/df;

/*	IF In_all  THEN 
                  DO;
			dp_cd=.; 
  			Test_type=2; 
  			ProbChiSq=1-PROBCHI( ChiSq, df);
			N_dps_tmp=N_dps;
                  END;
		IF dp_cd=.  THEN N_dps=N_dps_tmp;
        ELSE 				     N_dps=1;
		DROP N_dps_tmp;
	  */
  RUN;

  PROC SORT DATA=&tbl_name_hl_chisq_out.;
   BY dp_cd DESCENDING Test_type;
   RUN;

  %MEND;
 