/*HEADER------------------------------------------------------------------------
|
| PROGRAM:  chk_dir
|
| PURPOSE:  Checks for existense of the directory and if does not exist creates it.
			Works recursevly, i.e. if the parent directory does not exist it will create it.
			If the directory exist the macro does nothing and thus prevents error in the log
  
 20151123:  Allow UNIX/LINUX style directory names on Windows. The / is translated to \ before executing	mkdir
|
| USAGE EXAMPLES: 
  %LET dir1=\test1\test2;
  %chk_dir(&dir1);
+------------------------------------------------------------------------HEADER*/
  
%MACRO chk_dir(dir_name); 
 %LOCAL dir_option;
%GLOBAL DEBUG_FLAG2;

 /*%get_debugging_options; */

 %LOCAL _DEBUG_OPTIONS_L;
 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source2));
		
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN NONOTES NOSOURCE2; %END;

 %IF &SYSSCP. NE WIN %THEN %LET dir_option=-p;
 %ELSE						%LET dir_option=%STR() ;
   DATA _NULL_;
   LENGTH dir_name $ 2000 mkdir Message $  3000  ;
    dir_name="&dir_name";

    IF STRIP("&SYSSCP.") = "WIN"
	THEN dir_name=TRANSLATE(STRIP(dir_name),"\","/");

	IF INDEX(TRIM(LEFT(dir_name)),' ') >0 THEN dir_name=QUOTE(TRIM(LEFT(dir_name)));
	mkdir="mkdir &dir_option. " || TRIM(dir_name);

    IF FILEEXIST(TRIM(dir_name))=0 THEN rc=SYSTEM(TRIM(mkdir ));

   IF rc=. 	             THEN Message="Directory " || STRIP(dir_name) || " already exist" ;
	ELSE IF rc=0 THEN  Message= "Created directory " || STRIP(dir_name) ;
	ELSE 						   Message="Error creating directory " || STRIP(dir_name);

	  PUT  Message;
	
	RUN;
	OPTIONS &_DEBUG_OPTIONS_L.;
  %MEND;



  
