
	  %MACRO create_status_time_rpt(lib_in=infolder,rpt_dir_out=./
                                                             ,prefix_r=,rpt_format=pdf )  ;
		  /*
		Usage
           %LET 	RunID=dr1;
		   %LET prefix0=&runid._;
		   %PUT prefix_r=&prefix0.;

		   %LET prefix_r=&prefix0.;
		   %LET rpt_dir_out=&msoc.;

			 %create_status_time_rpt(rpt_dir_out=&msoc. , prefix_r=&prefix0. )  ;

			%LET prefix0=dc3_ ;

%create_status_time_rpt(lib_in=inf_dp0, rpt_dir_out=&msoc_dp0. 
                                             ,prefix_r=&prefix0.,rpt_format=rtf)  ;
		 */

   %PUT;
   %PUT -----   Start of the macro create_status_time_rpt;
   %PUT;

   %LOCAL n_errors NOTOC;
	
		 DATA  &prefix_r.track_tbl_r;
		   SET 	&lib_in..&prefix_r.track_tbl;
		   RETAIN  UTC_OFFSET_SEC_AC;

		   IF _N_=1 THEN UTC_OFFSET_SEC_AC=UTC_OFFSET_SEC;
		   
			  BY DP_CD MSREQID RUNID ITER_NB STEP_NB;

			   START_DTM_AC_TZ=START_DTM+UTC_OFFSET_SEC -UTC_OFFSET_SEC_AC;
			   END_DTM_AC_TZ=END_DTM+UTC_OFFSET_SEC -UTC_OFFSET_SEC_AC;

					  PREV_END_DTM=LAG(END_DTM);

		SAS_EXECUTE_TIME_SEC=END_DTM - START_DTM;

			  IF        FIRST.RUNID THEN  PREV_END_DTM=.;
			  ELSE SAS_WAIT_TIME_SEC=START_DTM - PREV_END_DTM;

	 FORMAT SAS_EXECUTE_TIME_SEC SAS_WAIT_TIME_SEC 8.2  
                     START_DTM_AC_TZ END_DTM_AC_TZ PREV_END_DTM DATETIME21.2  ;

	KEEP DP_CD  RUNID ITER_NB STEP_NB START_DTM  END_DTM  
			   START_DTM_AC_TZ END_DTM_AC_TZ PREV_END_DTM          
               STEP_RETURN_CD STEP_RETURN_CD 
                SAS_EXECUTE_TIME_SEC SAS_WAIT_TIME_SEC;
		  RUN;


 PROC SQL;
   CREATE TABLE &prefix_r.error_msg AS	
     SELECT	dp_cd
	                ,iter_nb
					,step_nb
					,step_return_cd
					,step_return_msg
	  FROM &lib_in..&prefix_r.track_tbl 
	    WHERE  step_return_cd >0	
		 ORDER BY   iter_nb
					          ,step_nb
					          ,step_return_cd DESC
				;
	QUIT;

	%LET n_errors=&sqlobs.;

ODS SELECT NONE;
ODS OUTPUT  Report= &prefix_r.track_tbl_rpt;

		PROC REPORT DATA=&prefix_r.track_tbl_r;
		   COLUMN  DP_CD ITER_NB STEP_NB 
                             SAS_WAIT_TIME_SEC SAS_EXECUTE_TIME_SEC 
                             START_DTM_AC_TZ END_DTM_AC_TZ;
			 
			  DEFINE DP_CD/GROUP  ;
			  DEFINE ITER_NB/GROUP;
			  DEFINE STEP_NB/GROUP;
			  DEFINE  SAS_WAIT_TIME_SEC/ANALYSIS SUM ;
			  DEFINE SAS_EXECUTE_TIME_SEC/ANALYSIS SUM ;
			  DEFINE START_DTM_AC_TZ/ANALYSIS MIN ;
              DEFINE END_DTM_AC_TZ/ANALYSIS MAX ;

			     BREAK AFTER DP_CD / SUMMARIZE ;
				/* RBREAK  AFTER/ SUMMARIZE ;  */
			
		RUN;
		QUIT;

		ODS SELECT ALL;

		 	 OPTIONS MISSING="";

		DATA &prefix_r.track_tbl_rpt2;
		  LENGTH  DP_CD_s ITER_NB_s STEP_NB_s $ 8
                        SAS_EXECUTE_TIME_SEC SAS_WAIT_TIME_SEC TOTAL_TIME_SEC 8;
		  SET &prefix_r.track_tbl_rpt END=last;;
		     BY NOTSORTED DP_CD ;

             DP_CD_s=COALESCEC(PUT(DP_CD,8.),"ALL"); 
			 ITER_NB_s=COALESCEC(PUT(ITER_NB,8.),"ALL");
		 	 STEP_NB_s=COALESCEC(PUT(STEP_NB,8.),"ALL");

			 TOTAL_TIME_SEC=SUM( SAS_EXECUTE_TIME_SEC, SAS_WAIT_TIME_SEC);

			 OUTPUT;

			 IF ITER_NB=. AND NOT last THEN 
							 DO;
			CALL MISSING(DP_CD_s, ITER_NB_s, STEP_NB_s,
                                   SAS_EXECUTE_TIME_SEC, SAS_WAIT_TIME_SEC,TOTAL_TIME_SEC,
                                   START_DTM_AC_TZ, END_DTM_AC_TZ);
                        OUTPUT;
						END;

		  RUN;

		    ODS PATH WORK.TEMPLAT(WRITE) Sashelp.Tmplmst (READ) ;
	  
 ODS PATH SHOW;
		  /* Allows title as text which is repeated as needed in the page.*/
PROC TEMPLATE;
    DEFINE STYLE styles.mimictitle;	
  /* PARENT=styles.pearl;  */
   PARENT=styles.default;
   CLASS USERTEXT FROM SYSTEMTITLE / 
     JUST=C;
   END;
RUN; 

 TITLE;

     %LET NOTOC=NOTOC;
	%IF &rpt_format.=rtf %THEN %LET NOTOC=;

 OPTIONS DEVICE=PNG;
ODS LISTING CLOSE	;

 ODS &rpt_format. FILE="&rpt_dir_out.&prefix_r.status_and_time_rpt.&rpt_format." 
						      &NOTOC. STYLE=styles.mimictitle NOGTITLE;

OPTIONS ORIENTATION=LANDSCAPE;
OPTIONS MISSING=" ";
ODS STARTPAGE=NO;

%IF &n_errors. =0 %THEN 
             %DO;

			 ODS TEXT="Convergence status";
PROC SQL;	
     SELECT	 iter_nb AS Total_numb_of_iter
					,reg_conv_in
					,reg_conv_msg
	  FROM &lib_in..&prefix_r.track_tbl 
	    WHERE  step_return_cd =0
               AND dp_cd=0
               AND 	last_iter_in=1
			   AND step_nb=2
				;
	QUIT;
			 %END;
%ELSE 
                %DO;

	ODS TEXT="Error messages in order of importance.";
	PROC PRINT DATA=&prefix_r.error_msg;
	RUN;

  	DATA _NULL_;
	  SET  &prefix_r.error_msg;
	  IF _N_ = 1 THEN 
                   DO;
           PUT "ERROR MESSAGES IN ORDER OF IMPORTANCE:";
		   PUT;
				  END;
	        PUT dp_cd=
	                iter_nb=
					step_nb=
					step_return_cd=
					step_return_msg=;
	RUN;

	        %END;

			 	ODS TEXT="Execution and wait time report";
				ODS TEXT="Overall DRA execution time is the same as the one for the central site (dp_cd=0) ";

	   PROC REPORT DATA=&prefix_r.track_tbl_rpt2;
		    COLUMN      DP_CD_s ITER_NB_s STEP_NB_s
                                   SAS_WAIT_TIME_SEC SAS_EXECUTE_TIME_SEC TOTAL_TIME_SEC
                                   START_DTM_AC_TZ END_DTM_AC_TZ ;
			 
			  DEFINE DP_CD_s/ "DP_CD"  DISPLAY  STYLE(COLUMN)=[JUST=R ]	;
			  DEFINE ITER_NB_s/ "ITER_NB" DISPLAY STYLE(COLUMN)=[JUST=R ];
			  DEFINE STEP_NB_s/"STEP_NB" DISPLAY STYLE(COLUMN)=[JUST=R ];
              DEFINE  SAS_WAIT_TIME_SEC/"SAS WAIT TIME SEC" DISPLAY ;
			  DEFINE SAS_EXECUTE_TIME_SEC/"SAS EXECUTE TIME SEC" DISPLAY ;
			  DEFINE TOTAL_TIME_SEC/"TOTAL TIME SEC" DISPLAY ;
			  DEFINE START_DTM_AC_TZ/ "START_DTM AC_TZ" DISPLAY ;
              DEFINE  END_DTM_AC_TZ/ "END_DTM AC_TZ" DISPLAY ;
		 	  FORMAT SAS_EXECUTE_TIME_SEC SAS_WAIT_TIME_SEC TOTAL_TIME_SEC 8.2;
		RUN;
		QUIT;

		TITLE;

	ODS &rpt_format. CLOSE;
    ODS LISTING;

   %PUT;
   %PUT -----   End of the macro create_status_time_rpt;
   %PUT;

%MEND;